#include <dos.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

#define vbuf (char far *)0xA0000000
#define uchar unsigned char
#define uint unsigned int
#define I asm

#define L 81 // altezza h_table
#define H 51 // larghezza h_table
#define N 11 // n di piani di shading (base inclusa)
#define OFF ( L * H ) // offset per passare da una tabella all'altra...

#define ftype int // tipo usato per il fixed point
#define FX 7 // shift per il fixed point
#define SH 2 // shift per il delta del patch
#define NX 4 // larghezza patch
#define NY 4 // altezza patch

#define ll 320

uchar fire3d[ 65535 ]; // array tridimensionale fuoco
uchar page[ 65535 ]; // pagina video
#define RAND_LEN 4096*4 // RAND_LEN deve essere una potenza di 2 !
uchar rand_tab[ 4096*4 ];
ftype h_table[ 81*51 ]; // tabella delle altezze da interpolare


void init_fire(void)
{
uint off;
 for(off=0; off< L * H * N; off++)
  fire3d[off] = 0;
}

void init_rand(unsigned s_rand)
{
uint i;
srand(s_rand);
 for(i=0; i<81*51*4; i++)
  rand_tab[i] = rand();
}


void draw_rand(void)
{
uint i, off;
int ix, iy;

i = rand();
off = OFF*(N-1); // inizio piano di base

for(iy=0; iy<H; iy+=2, off+=L)
 for(ix=0; ix<L; ix+=2, off+=2)
 {
  fire3d[off] =
//  fire3d[off+1] =
//  fire3d[off+L] =
  fire3d[off+L+1] =
   rand_tab[(i++) & (RAND_LEN-1)]; // AND-MOD super stuff !!
 }


}



void shade3d(void)
{
uint off;
int col;
for(off=0; off<L*H*(N-1); off++)
 {
  col = (
			 fire3d[off-L+OFF] +

	fire3d[off-1+OFF] + fire3d[off+1+OFF] +

			 fire3d[off+L+OFF]

			   // sotto

		      + (fire3d[off]+fire3d[off+OFF])*2
	  );

 col>>=3;
  if(col)col--;

 fire3d[off] = col;

 }

}




void upgrade_table(void)
{
uint off = L, yy;
int ix, col;

 for(yy=0; yy<H*L; yy+=L)
  for(ix=0; ix<L; ix++)
  {
   // col=fire3d[off]-32;
   /*
   col+=col<<8;
   *((int far *)vbuf + ix+yy) = *((int far *)vbuf + ix + yy + 1) =
   *((int far *)vbuf + ix+yy+160) = *((int far *)vbuf + ix+yy+161) = col;
   */
  h_table[ ix + yy ] = (fire3d[ off ]) << (FX+1);

   off++;

  }

}




void interpolate(void)
{
int ix, iy, x, line;
uint off;
ftype sy, ey, dsy, dey;
ftype sx, dx;

// inizia l'interpolazione dei patch...

for(iy=0; iy<H; iy++)
 for(ix=0; ix<L-1; ix++)
 {
  off = ix + iy * L;

  dsy = (h_table[off+L] - h_table[off]) >> SH;
  dey = (h_table[off+L+1] - h_table[off+1]) >> SH;
  sy = h_table[off];
  ey = h_table[off+1];

  off = (ix + iy*64 + iy*256) << SH;

  for(line=0; line<NY; line++)
  {
   dx = (ey - sy) >> SH;
   sx = sy;
    for(x=0; x < NX; x++)
    {
     *(page + off) = sx >> FX;
     off++;
     sx+=dx;
    }
   off+=320 - NX;
   sy+=dsy;
   ey+=dey;
  }

}
}


void show_page(void)
{
register uint off=0;

 // aspetta il vertical retrace
I mov dx, 3dah
 rtloop:
I in al, dx
I test al, 8
I jz rtloop // aspetta che sia off
 rtloop2:
I in al, dx
I test al, 8
I jnz rtloop2 // aspetta che sia on

for(; off<32000; off++)
 *((int far *)0xA0000000+off)=*((int *)page+off);

}


void main(void)
{
uint off, yy, iy, iz;
int ix;

I mov ax, 13h
I int 10h


// per impostare una palette invece di un'altra, togli & aggiungi /*...*/

/*
// fuoco tarocco

outp(968, 32+16);// 1colore da modificare, poi va avanti R, G, B; R, G, B;...
// nero - rosso
for(yy=0; yy<32; yy++) { outp(969, yy*2); outp(969, 0); outp(969, 0); }
// rosso - giallo
for(yy=0; yy<16; yy++) { outp(969, 63); outp(969, yy*4); outp(969, 0); }
// giallo - bianco
for(yy=0; yy<16; yy++) { outp(969, 63); outp(969, 63); outp(969, yy*4); }
// bianco
for(yy=0; yy<255-(32+16) -32 -16 -16; yy++)
 { outp(969, 63); outp(969, 63); outp(969, 63); }
*/

/*
// mmmh... allegre nuvolette!
outp(968, 0);
for(yy=0; yy<32; yy++)
{ off=yy*2;
  outp(969, 0); outp(969, 0); outp(969, off); }
for(yy=0; yy<128; yy++)
{ off=yy/2.0;
  outp(969, off); outp(969, off); outp(969, 63); }
*/

/*
// smog
outp(968,1);
for(yy=0; yy<255; yy++)
 { outp(969, yy/2.5);outp(969, yy/2.5);outp(969, yy/2.5); }
*/


// questo mi ricorda un certo PIE...
outp(968, 1);
for(yy=0; yy<255; yy++)
{
off = abs(sin(M_PI/128.0*yy*3)*63);
 outp(969, off);
 outp(969, off);
 outp(969, 0);
}


// mette a 0 tutto l'array fuoco3D (credo che non serva, ma fa pi scena...)
init_fire();
// precalcola i valori random
init_rand((unsigned)("BrodericK"));

while(! kbhit())
{
 // disegna a muzzo la base
 draw_rand();
 // solito shading (ma  3D!) (ecco perch la procedura si chiama cos...!)
 shade3d();
 // aggiorna h_table[] coi valori dell'ultimo piano d'interpolazione
 upgrade_table();
 // disegna su pagina video interpolando h_table[]
 interpolate();
 // mostra la pagina video ( con gran scalpore della folla che esulta )
 show_page();
} // end  while(!kbhit())

// becca quel bastardo di un carattere ambulante che se ne sta nel buffer !!!
getch();

// mette in ax il valore 3 decimale
I mov ax, 3
// esegue la routine di interrupt numero 10 esadecimale
I int 10h
// tutto questo per dirvi che siamo ora in modalit testo (miiii!)
}